/*
	TVTest vOC

	GV-RCKIT3g
*/


#include <windows.h>
#include <tchar.h>
#include <shlwapi.h>
#define TVTEST_PLUGIN_CLASS_IMPLEMENT
#include "TVTestPlugin.h"
#include "resource.h"

#pragma comment(lib,"shlwapi.lib")

// vOCNX
class ZapTest : public TVTest::CTVTestPlugin
{
	bool m_fInitialized;	// ς݂?
	UINT_PTR TimerId;		// ^C}[ID

	bool InitializePlugin();

	static LRESULT CALLBACK EventCallback(UINT Event,LPARAM lParam1,LPARAM lParam2,void *pClientData);
	static BOOL CALLBACK MessageCallback(HWND hwnd,UINT uMsg,WPARAM wParam,LPARAM lParam,
										 LRESULT *pResult,void *pClientData);

public:
	ZapTest();
	virtual bool GetPluginInfo(TVTest::PluginInfo *pInfo);
	virtual bool Initialize();
	virtual bool Finalize();
};


ZapTest::ZapTest()
	: m_fInitialized(false)
{
}


bool ZapTest::GetPluginInfo(TVTest::PluginInfo *pInfo)
{
	// vOC̏Ԃ
	pInfo->Type           = TVTest::PLUGIN_TYPE_NORMAL;
	pInfo->Flags          = 0;
	pInfo->pszPluginName  = L"ZapTest";
	pInfo->pszCopyright   = L"Shizma Aonuma";
	pInfo->pszDescription = L"5bɈ`lAbv{^܂B";
	return true;
}


bool ZapTest::Initialize()
{
	// 

	// CxgR[obN֐o^
	m_pApp->SetEventCallback(EventCallback,this);

	return true;
}


// vOCLɂꂽ̏
bool ZapTest::InitializePlugin()
{
	if (!m_fInitialized) {
		// bZ[W̓o^
		TimerId=::SetTimer(m_pApp->GetAppWindow(), 5050, 10000, NULL);
		if (TimerId==0){
			::MessageBox(m_pApp->GetAppWindow(),
					 TEXT("LŃG[܂B"),NULL,
					 MB_OK);
			return false;
		}

		m_fInitialized=true;
	}

	// bZ[WR[obN֐o^
	m_pApp->SetWindowMessageCallback(MessageCallback,this);

	return true;
}


bool ZapTest::Finalize()
{
	// I

	return true;
}


// CxgR[obN֐
// CxgNƌĂ΂
LRESULT CALLBACK ZapTest::EventCallback(UINT Event,LPARAM lParam1,LPARAM lParam2,void *pClientData)
{
	ZapTest *pThis=static_cast<ZapTest*>(pClientData);

	switch (Event) {
	case TVTest::EVENT_PLUGINENABLE:
		// vOC̗LԂω
		if (lParam1!=0) {
			if (!pThis->InitializePlugin()) {
				::MessageBox(pThis->m_pApp->GetAppWindow(),
							 TEXT("ŃG[܂B"),NULL,
							 MB_OK | MB_ICONEXCLAMATION);
				return FALSE;
			}
		} else {
			KillTimer(NULL, pThis->TimerId);
			pThis->m_pApp->SetWindowMessageCallback(NULL);
		}
		return TRUE;

//	case TVTest::EVENT_CONTROLLERFOCUS:
//		// ̃vZX̑ΏۂɂȂ
//		pThis->SetWindow(reinterpret_cast<HWND>(lParam1));
//		return TRUE;
	}
	return 0;
}


// bZ[WR[obN֐
BOOL CALLBACK ZapTest::MessageCallback(HWND hwnd,UINT uMsg,WPARAM wParam,LPARAM lParam,
											LRESULT *pResult,void *pClientData)
{
	ZapTest *pThis=static_cast<ZapTest*>(pClientData);

	if (uMsg==WM_TIMER && wParam==pThis->TimerId) {
		// `lɑ
		pThis->m_pApp->SetNextChannel(true);
		return TRUE;
	}
	return FALSE;
}



// vOCNX̃CX^X𐶐
TVTest::CTVTestPlugin *CreatePluginClass()
{
	return new ZapTest;
}
